% Open fold helpers
%_traceback = 1;
%_debug_info = 1;

% Support for opening/closing folds in a simple way.
% To open a closed fold, press ENTER on '...'.
% To close an open fold, press ESC+BackSpace somwhere inside the fold.
require("keydefs");

define try_enter_fold()
{
        push_spot();
        go_right_1;
        is_line_hidden();             % On Stack
        pop_spot();

        if (()) {    % is_line_hidden()
                variable f = __get_reference("fold_open_fold");

                if (f != NULL)
                        @f();
        } else {
                variable old_newline = NULL;

                if (blocal_var_exists("old_newline")) {
                        old_newline = get_blocal_var("old_newline");

			if (old_newline != NULL)
				% Avoid recursion
				if (strcmp(old_newline, "try_enter_fold") != 0) {
					@__get_reference(old_newline);
					return;
				}
		}
		% failsafe default
                call("newline_and_indent");
        }
}

define fold_mode_hook()
{
        variable old_newline;

        if (blocal_var_exists("old_newline"))
                return;     % Already hooked, I guess

        (, old_newline) = get_key_binding("
");
        create_blocal_var("old_newline");
        set_blocal_var(old_newline, "old_newline");
        local_setkey("try_enter_fold", "
");
        local_setkey("fold_close_fold", ""+Key_BS);
}
