% Misc. Functions.
%_traceback = 1;
%_debug_info = 1;

custom_variable("C_Switch_Offset", 0);
require("man");
require("wordsrch");

% Grrr, jed can't show the buffer path in status line...
define show_buffer_path()
{
   variable file,dir,buffer,flags;

   (file,dir,buffer,flags) = getbuf_info();
   vmessage("%s: %s%s - 0x%X", buffer, dir, file, flags);
}

% A hacked version of man.
static define _unix_man(subj)
{
   variable buf = "*manual-entry*", msg = "Getting man page...";

   !if ( strlen (subj) ) return;

   pop2buf (buf);
   set_readonly (0);
   erase_buffer ();
   flush (msg);
#ifdef OS2
   () = run_shell_cmd (sprintf ("man %s 2> nul", subj));
#else
   putenv("PAGER=more");
   () = run_shell_cmd (sprintf ("man %s 2> /dev/null", subj));
#endif
   man_clean_manpage ();
   bob ();
   set_buffer_modified_flag (0);
   most_mode ();
   set_readonly (1);
}

define man_this_item()
{
        variable buf = "*manual-entry*";
        variable s;
        variable r;

        s = get_word();
        r = get_doc_string_from_file("/u/sdi/local/jed-cdoc/all.txt", s);
        if (r != NULL) {
                whatbuf(buf);
                if (bufferp(buf))
                    delbuf(buf);
                pop2buf(buf);
                insert(r);
                bob;
                set_buffer_modified_flag(0);
                pop2buf(());
                return;
        }
#ifndef IBMPC_SYSTEM
        _unix_man(s);
#endif
}

% A wrapper around help_for_function.
define sau_help_for_this_function()
{
        help_for_function(get_word());
        % I already have a window for *function-help* buffer, so this should do the trick.
        pop2buf("*function-help*");
        most_mode();
}

define saurus_help()
{
	variable mode;

	(mode, ) = what_mode();
	if (mode == "C")
		man_this_item();
	else if (mode == "SLang")
		sau_help_for_this_function();
	else {
		(,,mode, ) = getbuf_info();
		if (mode == "*manual-entry*")
			man_this_item();
		else
			sau_help_for_this_function();
	}
}

define saurus_comment()
{
        insert("/* DS  */");
        left(3);
}

define indent_all()
{
        push_spot();
        bob();
        do {
                indent_line();
        } while (down(1));
        pop_spot();
}

% Saurus Choice
define sau_indent()
{
        C_INDENT           = 8;
        C_BRACE            = 0;        % amount of space to indent brace
        C_BRA_NEWLINE      = 0;
        C_CONTINUED_OFFSET = 8;
        C_Colon_Offset     = 4;        % Controls the indentation of case statements.
%       C_Switch_Offset    = 0;
        TAB_DEFAULT        = 8;
        TAB                = 8;
        call("redraw");
}

% paola Choice
define paola_indent()
{
        C_INDENT           = 0;
        C_BRACE            = 0;        % amount of space to indent brace
        C_BRA_NEWLINE      = 0;
        C_CONTINUED_OFFSET = 0;
        C_Colon_Offset     = 0;        % Controls the indentation of case statements.
%       C_Switch_Offset    = 0;
        TAB_DEFAULT        = 3;
        TAB                = 3;        % No Tabs Please
        call("redraw");
}

% LLoyd Choice
define lloyd_indent()
{
        C_INDENT           = 3;
        C_BRACE            = 0;        % amount of space to indent brace
        C_BRA_NEWLINE      = 0;
        C_CONTINUED_OFFSET = 3;
        C_Colon_Offset     = 0;        % Controls the indentation of case statements.
        C_Switch_Offset    = 3;
        TAB_DEFAULT        = 8;
        TAB                = 0;        % No Tabs Please
        call("redraw");
}

% Bound to ^D
define ashell_send_eof()
{
        message("sending exit...");
        bol();
        call("kill_line");
        insert("exit");
        ashell_send_input();
}

define sau_ashell()
{
        % My default PS1 is full of weird things. set to some saner value.
        putenv("PS1=\\u@\\h: \\d \\t\\n\\w\\\\$");
        ERROR_BLOCK {
                % If already running, switch to it.
                if (bufferp("*ashell*"))
                        sw2buf("*ashell*");
        }
        ashell();
        definekey("ashell_send_eof", "^D", "AShellMap");
}

define trim_all_eols()
{
        push_mark();
        bob();
        do {
                eol();
                trim();
        } while (down_1());
        pop_mark_1();
}

define untab_buffer()
{
        push_spot();
        bob();
        push_mark();
        eob();
        untab();
        pop_spot();
}

define take_this_diff3()
{
        variable seps = [ ">>>>>>>", "<<<<<<<", "|||||||", "=======", ">>>>>>>"];
        %                 last       first      mid 1      mid 2      last (again)
        variable i;
        variable found;

        push_mark();
        found = 0;
        for (i=3; i >= 0; i--)
        {
                if (bol_bsearch(seps[i]) != 0)
                {
                        found = 1;
                        break;
                }
        }
        if (found == 0)
        {
                pop_mark(1);
                error("cannot find Prec separator ! ");
        }
        if (i == 0)
        {
                pop_mark(1);
                error("found last separator!");
        }

        push_mark();
        right(1);
        if (bol_bsearch(seps[1]) == 0)
        {
                pop_mark(0);
                pop_mark(1);
                error("cannot find start separator !");
        }
        push_mark();
        if (bol_fsearch(seps[0]) == 0)
        {
                pop_mark(0);
                pop_mark(0);
                pop_mark(1);
                error("cannot find end separator !");
        }

        eol();
        right(1);
        narrow();

        pop_mark(1);

        eol();
        right(1);
        push_mark();
        bob(); % narrowed
        call("kill_region");

        found = 0;
        for (i=2; i <= 4; i++)
        {
                if (bol_fsearch(seps[i]) != 0)
                {
                        found = 1;
                        break;
                }
        }
        if (found == 0)
        {
                pop_mark(1);
                error("cannot find Following separator ! ");
        }

        push_mark();
        eob(); % narrowed
        bol();
        call("kill_region");
        widen();
        pop_mark(0);
}

define center()
{
        variable len;

        push_mark();
        bol();
        trim();
        eol();
        trim();
        len = (80 - what_column())/2;
        if (len > 0) {
                bol();
                insert_spaces(len);
        }
        pop_mark(0);
}

% Get text enclosed by strings. You may use
% get_enclosed_strings("<", ">"), on a C source to get a list of files included.
define get_enclosed_strings(start, end)
{
        variable size;

        bob();
        push_mark();
        size = fsearch(start);
        while (size > 0) {
                right(size);
                call("kill_region");
                size = fsearch(end);
                insert("\n");
                push_mark();
                right(size);
                size = fsearch(start);
        }
        eob();
        call("kill_region");
}

% Hack mode to some files used by me with a syntax very html like.
define mod_mode()
{
        html_mode();
        define_syntax('%', '#', "html");
}
